/****************************************************/
/* Fichier contenant des fonctions d'interface avec */
/*     l'utilisateur pour l'entree des donnees      */
/****************************************************/


#include <stdio.h>
#include "struct.h"
#include "pointeur.h"
#include "entree.h"
#include "scrut.h"

/* Fonction demandant a l'utilisateur d'entrer les numeros */
/* des minterms qui valent 1 et de ceux indifferents (pour */
/* les fonctions incompletes) */

void entree(n,comp,incomp)
    int n;
    mint ** comp;
    mint ** incomp;
{
    /* les variables comp et incomp seront modifiees par parametre */

    int i, p;
    mint * ent;

    p = 1;
    for (i = 1; i <= n; i++)
	p = p * 2;

    * comp = NULL;
    printf("Numeros des termes valant 1 :\n");
    i = 1;
    while (i != 100)
    {
	printf("  terme no : ");
	i = p;
	while ((i < 0) || ((i != 100) && (i >= p)))
	    i=scrut();
	if (i != 100)
	{
	    if (*comp == NULL)
	    {
		*comp = new_mint(i);
		ent = *comp;
	    }
	    else
	    {
		ent->next = new_mint(i);
		ent = ent->next;
	    }
	}
    }

    *incomp = NULL;
    printf("\nNumeros des termes valant phi :\n");
    i = 1;
    while (i != 100)
    {
	printf("  terme no : ");
	i = p;
	while ((i < 0) || ((i != 100) && (i >= p)))
	    i=scrut();
	if (i != 100)
	{
	    if (*incomp == NULL)
	    {
		*incomp = new_mint(i);
		ent = *incomp;
	    }
	    else
	    {
		ent->next = new_mint(i);
		ent = ent->next;
	    }
	}
    }
}


/* Fonction demandant a l'utilisateur d'entrer, s'il le */
/* souhaite, ses propres variables (la valeur NULL est  */
/* retournee si l'utilisateur a choisi les variables    */
/* predefinies) */

varia * variable(i,n)
    int i,n;
{
    varia * list_var, * renvoi;
    int convent, poids;
    char * var = (char *) malloc(8);

    printf("\nVoulez vous entrer :\n");
    printf("  - vos propres noms de variables (tapez 1)\n");
    printf("  - adopter l'ordre conventionnel (tapez 2)\n");
    printf("\n\tVotre choix ? ");
    convent=scrut();

    if (convent == 1)
    {
	printf("\nEntrez vos variables dans l'ordre decroissant des poids...\n");
	if (i == 2)
	    printf("  (nom des entrees, puis des variables internes)\n");
	for (poids=1;poids<=n;poids++)
	{
	    printf("Variable ? ");
	    scanf("%s",var);

	    if (poids == 1)
	    {
		list_var = new_varia(var);
		renvoi = list_var;
	    }
	    else
	    {
		renvoi->suiv = new_varia(var);
		renvoi = renvoi->suiv;
	    }
	}
    }
    else
	list_var = NULL;

    free(var);

    return list_var;
}
