/*************************************************/
/* Fichier contenant les fonctions de generation */
/*  automatique de variables pour le sequentiel  */
/*************************************************/



#include <stdio.h>
#include "struct.h"
#include <stdlib.h>


/* generation d'un nom du type e1,e2,e3,... */

varia * new_entree(n)
    int n;
{
    varia * new = (varia*) malloc(sizeof(varia));

    new->var = (char*) malloc(8);
    sprintf(new->var,"e%d",n);
    new->suiv = NULL;

    return new;
}


/* generation d'un nom du type a,b,c,... */

varia * new_etat(n)
    int n;
{
    varia * new = (varia*) malloc(sizeof(varia));

    new->var = (char*) malloc(8);
    sprintf(new->var,"%c",96+n);
    new->suiv = NULL;

    return new;
}


/* Fonction de creation de la liste des variables */

varia * cree_liste(ex,in)
    int ex,in;
{
    varia * list, * temp;
    int compt = 1;

    list = NULL;

    /* generation de noms pour les entrees */
    while (compt <= ex)
    {
	if (list == NULL)
	{
	    list = new_entree(compt);
	    temp = list;
	}
	else
	{
	    temp->suiv = new_entree(compt);
	    temp = temp->suiv;
	}
	compt ++;
    }

    compt = 1;

    /* generation de noms pour les etats */
    while (compt <= in)
    {
	if (list == NULL)
	{
	    list = new_etat(compt);
	    temp = list;
	}
	else
	{
	    temp->suiv = new_etat(compt);
	    temp = temp->suiv;
	}
	compt ++;
    }

    return list;
}
