struct lig_base
{
    int min;
    int nb;
    struct lig_base * suive;
};

typedef struct lig_base base;

struct no_minterm
{
    int numero;
    struct no_minterm * next;
};

typedef struct no_minterm mint;

struct cellule
{
    int valeur;
    int masque;
    struct cellule * suiv;
    mint * no;
};

typedef struct cellule cell;

struct ensemble
{
    cell * element;
    struct ensemble * autre;
};

typedef struct ensemble ens;

struct variable
{
    char * var;
    struct variable * suiv;
};

typedef struct variable varia;

struct poids_variable
{
    int poids;
    int valeur;
    struct poids_variable * suiv;
};

typedef struct poids_variable poids_var;

struct tableau_poids_var
{
    poids_var * terme;
    struct tableau_poids_var * suiv;
};

typedef struct tableau_poids_var tab_var;

struct binaire
{
    int poids;
    int bin;
    struct binaire * suiv;
};

typedef struct binaire bin;

struct list_binaire
{
    int valeur;
    bin * terme;
    struct list_binaire * suiv;
};

typedef struct list_binaire list_bin;

struct transition
{
    int var;
    mint * comp;
    mint * incomp;
    mint * comp1;
    mint * incomp1;
    struct transition * suiv;
};

typedef struct transition trans;
